<?php
/**
 * The template to display blog archive
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

/*
Template Name: Blog archive
*/

/**
 * Make page with this template and put it into menu
 * to display posts as blog archive
 * You can setup output parameters (blog style, posts per page, parent category, etc.)
 * in the Theme Options section (under the page content)
 * You can build this page in the WPBakery Page Builder to make custom page layout:
 * just insert %%CONTENT%% in the desired place of content
 */

// Get template page's content
$playhockey_content = '';
$playhockey_blog_archive_mask = '%%CONTENT%%';
$playhockey_blog_archive_subst = sprintf('<div class="blog_archive">%s</div>', $playhockey_blog_archive_mask);
if ( have_posts() ) {
	the_post(); 
	if (($playhockey_content = apply_filters('the_content', get_the_content())) != '') {
		if (($playhockey_pos = strpos($playhockey_content, $playhockey_blog_archive_mask)) !== false) {
			$playhockey_content = preg_replace('/(\<p\>\s*)?'.$playhockey_blog_archive_mask.'(\s*\<\/p\>)/i', $playhockey_blog_archive_subst, $playhockey_content);
		} else
			$playhockey_content .= $playhockey_blog_archive_subst;
		$playhockey_content = explode($playhockey_blog_archive_mask, $playhockey_content);
	}
}

// Prepare args for a new query
$playhockey_args = array(
	'post_status' => current_user_can('read_private_pages') && current_user_can('read_private_posts') ? array('publish', 'private') : 'publish'
);
$playhockey_args = playhockey_query_add_posts_and_cats($playhockey_args, '', playhockey_get_theme_option('post_type'), playhockey_get_theme_option('parent_cat'));
$playhockey_page_number = get_query_var('paged') ? get_query_var('paged') : (get_query_var('page') ? get_query_var('page') : 1);
if ($playhockey_page_number > 1) {
	$playhockey_args['paged'] = $playhockey_page_number;
	$playhockey_args['ignore_sticky_posts'] = true;
}
$playhockey_ppp = playhockey_get_theme_option('posts_per_page');
if ((int) $playhockey_ppp != 0)
	$playhockey_args['posts_per_page'] = (int) $playhockey_ppp;
// Make a new query
query_posts( $playhockey_args );
// Set a new query as main WP Query
$GLOBALS['wp_the_query'] = $GLOBALS['wp_query'];

// Set query vars in the new query!
if (is_array($playhockey_content) && count($playhockey_content) == 2) {
	set_query_var('blog_archive_start', $playhockey_content[0]);
	set_query_var('blog_archive_end', $playhockey_content[1]);
}

get_template_part('index');
?>