<?php
/**
 * The Classic template to display the content
 *
 * Used for index/archive/search.
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_blog_style = explode('_', playhockey_get_theme_option('blog_style'));
$playhockey_columns = empty($playhockey_blog_style[1]) ? 1 : max(1, $playhockey_blog_style[1]);
$playhockey_expanded = !playhockey_sidebar_present() && playhockey_is_on(playhockey_get_theme_option('expand_content'));
$playhockey_post_format = get_post_format();
$playhockey_post_format = empty($playhockey_post_format) ? 'standard' : str_replace('post-format-', '', $playhockey_post_format);
$playhockey_animation = playhockey_get_theme_option('blog_animation');

?><article id="post-<?php the_ID(); ?>" 
	<?php post_class( 'post_item post_layout_chess post_layout_chess_'.esc_attr($playhockey_columns).' post_format_'.esc_attr($playhockey_post_format) ); ?>
	<?php echo (!playhockey_is_off($playhockey_animation) ? ' data-animation="'.esc_attr(playhockey_get_animation_classes($playhockey_animation)).'"' : ''); ?>
	>

	<?php
	// Add anchor
	if ($playhockey_columns == 1 && shortcode_exists('trx_sc_anchor')) {
		echo do_shortcode('[trx_sc_anchor id="post_'.esc_attr(get_the_ID()).'" title="'.the_title_attribute( array( 'echo' => false ) ).'"]');
	}

	// Featured image
	playhockey_show_post_featured( array(
											'class' => $playhockey_columns == 1 ? 'trx-stretch-height' : '',
											'show_no_image' => true,
											'thumb_bg' => true,
											'thumb_size' => playhockey_get_thumb_size(
																	strpos(playhockey_get_theme_option('body_style'), 'full')!==false
																		? ( $playhockey_columns > 1 ? 'huge' : 'original' )
																		: (	$playhockey_columns > 2 ? 'big' : 'huge')
																	)
											) 
										);

	?><div class="post_inner"><div class="post_inner_content"><?php 

		?><div class="post_header entry-header"><?php 
			do_action('playhockey_action_before_post_title'); 

			// Post title
			the_title( sprintf( '<h3 class="post_title entry-title"><a href="%s" rel="bookmark">', esc_url( get_permalink() ) ), '</a></h3>' );
			
			do_action('playhockey_action_before_post_meta'); 

			// Post meta
			$playhockey_post_meta = playhockey_show_post_meta(array(
                    'categories' => false,
                    'date' => true,
                    'edit' => false,
                    'author' => false,
                    'seo' => false,
                    'share' => false,
                    'counters' => 'comments'	//comments,likes,views - comma separated in any combination
                )
            );

                playhockey_show_layout($playhockey_post_meta);
		?></div><!-- .entry-header -->
	
		<div class="post_content entry-content">
			<div class="post_content_inner">
				<?php
				$playhockey_show_learn_more = !in_array($playhockey_post_format, array('link', 'aside', 'status', 'quote'));
				if (has_excerpt()) {
					the_excerpt();
				} else if (strpos(get_the_content('!--more'), '!--more')!==false) {
					the_content( '' );
				} else if (in_array($playhockey_post_format, array('link', 'aside', 'status', 'quote'))) {
					the_content();
				} else if (substr(get_the_content(), 0, 1)!='[') {
					the_excerpt();
				}
				?>
			</div>
			<?php
			// Post meta
			if (in_array($playhockey_post_format, array('link', 'aside', 'status', 'quote'))) {
				playhockey_show_layout($playhockey_post_meta);
			}
			// More button
			if ( $playhockey_show_learn_more ) {
				?><p><a class="more-link" href="<?php the_permalink(); ?>"><?php esc_html_e('Read more', 'playhockey'); ?></a></p><?php
			}
			?>
		</div><!-- .entry-content -->

	</div></div><!-- .post_inner -->

</article>