<?php
/**
 * The Gallery template to display posts
 *
 * Used for index/archive/search.
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_blog_style = explode('_', playhockey_get_theme_option('blog_style'));
$playhockey_columns = empty($playhockey_blog_style[1]) ? 2 : max(2, $playhockey_blog_style[1]);
$playhockey_post_format = get_post_format();
$playhockey_post_format = empty($playhockey_post_format) ? 'standard' : str_replace('post-format-', '', $playhockey_post_format);
$playhockey_animation = playhockey_get_theme_option('blog_animation');
$playhockey_image = wp_get_attachment_image_src( get_post_thumbnail_id(get_the_ID()), 'full' );

?><article id="post-<?php the_ID(); ?>" 
	<?php post_class( 'post_item post_layout_portfolio post_layout_gallery post_layout_gallery_'.esc_attr($playhockey_columns).' post_format_'.esc_attr($playhockey_post_format) ); ?>
	<?php echo (!playhockey_is_off($playhockey_animation) ? ' data-animation="'.esc_attr(playhockey_get_animation_classes($playhockey_animation)).'"' : ''); ?>
	data-size="<?php if (!empty($playhockey_image[1]) && !empty($playhockey_image[2])) echo intval($playhockey_image[1]) .'x' . intval($playhockey_image[2]); ?>"
	data-src="<?php if (!empty($playhockey_image[0])) echo esc_url($playhockey_image[0]); ?>"
	>

	<?php
	$playhockey_image_hover = 'icon';
	if (in_array($playhockey_image_hover, array('icons', 'zoom'))) $playhockey_image_hover = 'dots';
	// Featured image
	playhockey_show_post_featured(array(
		'hover' => $playhockey_image_hover,
		'thumb_size' => playhockey_get_thumb_size( strpos(playhockey_get_theme_option('body_style'), 'full')!==false || $playhockey_columns < 3 ? 'masonry-big' : 'masonry' ),
		'thumb_only' => true,
		'show_no_image' => true,
		'post_info' => '<div class="post_details">'
							. '<h2 class="post_title"><a href="'.esc_url(get_permalink()).'">'. esc_html(get_the_title()) . '</a></h2>'
							. '<div class="post_description">'
								. playhockey_show_post_meta(array(
									'categories' => true,
									'date' => true,
									'edit' => false,
									'seo' => false,
									'share' => true,
									'counters' => 'comments',
									'echo' => false
									))
								. '<div class="post_description_content">'
									. apply_filters('the_excerpt', get_the_excerpt())
								. '</div>'
								. '<a href="'.esc_url(get_permalink()).'" class="theme_button post_readmore"><span class="post_readmore_label">' . esc_html__('Learn more', 'playhockey') . '</span></a>'
							. '</div>'
						. '</div>'
	));
	?>
</article>