<?php
/**
 * The Portfolio template to display the content
 *
 * Used for index/archive/search.
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_blog_style = explode('_', playhockey_get_theme_option('blog_style'));
$playhockey_columns = empty($playhockey_blog_style[1]) ? 2 : max(2, $playhockey_blog_style[1]);
$playhockey_post_format = get_post_format();
$playhockey_post_format = empty($playhockey_post_format) ? 'standard' : str_replace('post-format-', '', $playhockey_post_format);
$playhockey_animation = playhockey_get_theme_option('blog_animation');

?><article id="post-<?php the_ID(); ?>" 
	<?php post_class( 'post_item post_layout_portfolio post_layout_portfolio_'.esc_attr($playhockey_columns).' post_format_'.esc_attr($playhockey_post_format) ); ?>
	<?php echo (!playhockey_is_off($playhockey_animation) ? ' data-animation="'.esc_attr(playhockey_get_animation_classes($playhockey_animation)).'"' : ''); ?>
	>

	<?php
	$playhockey_image_hover = playhockey_get_theme_option('image_hover');
	// Featured image
	playhockey_show_post_featured(array(
		'thumb_size' => playhockey_get_thumb_size(strpos(playhockey_get_theme_option('body_style'), 'full')!==false || $playhockey_columns < 3 ? 'masonry-big' : 'masonry'),
		'show_no_image' => true,
		'class' => $playhockey_image_hover == 'dots' ? 'hover_with_info' : '',
		'post_info' => $playhockey_image_hover == 'dots' ? '<div class="post_info">'.esc_html(get_the_title()).'</div>' : ''
	));
	?>
</article>