<?php
/**
 * The Sticky template to display the sticky posts
 *
 * Used for index/archive
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_columns = max(1, min(3, count(get_option( 'sticky_posts' ))));
$playhockey_post_format = get_post_format();
$playhockey_post_format = empty($playhockey_post_format) ? 'standard' : str_replace('post-format-', '', $playhockey_post_format);
$playhockey_animation = playhockey_get_theme_option('blog_animation');

?><div class="column-1_<?php echo esc_attr($playhockey_columns); ?>"><article id="post-<?php the_ID(); ?>" 
	<?php post_class( 'post_item post_layout_sticky post_format_'.esc_attr($playhockey_post_format) ); ?>
	<?php echo (!playhockey_is_off($playhockey_animation) ? ' data-animation="'.esc_attr(playhockey_get_animation_classes($playhockey_animation)).'"' : ''); ?>
	>

	<?php
	if ( is_sticky() && is_home() && !is_paged() ) {
		?><span class="post_label label_sticky"></span><?php
	}

	// Featured image
	playhockey_show_post_featured(array(
		'thumb_size' => playhockey_get_thumb_size($playhockey_columns==1 ? 'big' : ($playhockey_columns==2 ? 'med' : 'avatar'))
	));

	if ( !in_array($playhockey_post_format, array('link', 'aside', 'status', 'quote')) ) {
		?>
		<div class="post_header entry-header">
			<?php
			// Post title
			the_title( sprintf( '<h2 class="post_title entry-title"><a href="%s" rel="bookmark">', esc_url( get_permalink() ) ), '</a></h2>' );
			// Post meta
            // Post meta
            playhockey_show_post_meta(array(
                    'categories' => false,
                    'date' => true,
                    'edit' => false,
                    'author' => false,
                    'seo' => false,
                    'share' => false,
                    'counters' => 'comments'	//comments,likes,views - comma separated in any combination
                )
            );
			?>
		</div><!-- .entry-header -->
		<?php
	}
    // Post content area
    ?><div class="post_content_inner"><?php
            if (has_excerpt()) {
                the_excerpt();
            } else if (strpos(get_the_content('!--more'), '!--more')!==false) {
                the_content( '' );
            } else if (in_array($playhockey_post_format, array('link', 'aside', 'status', 'quote'))) {
                the_content();
            } else if (substr(get_the_content(), 0, 1)!='[') {
                the_excerpt();
            }
            ?></div><?php
        ?>
</article></div>