<?php
/**
 * The Sidebar containing the main widget areas.
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_sidebar_position = playhockey_get_theme_option('sidebar_position');
if (playhockey_sidebar_present()) {
	ob_start();
	$playhockey_sidebar_name = playhockey_get_theme_option('sidebar_widgets');
	playhockey_storage_set('current_sidebar', 'sidebar');
    if ( is_active_sidebar( $playhockey_sidebar_name ) ) {
        dynamic_sidebar( $playhockey_sidebar_name );
    }
	$playhockey_out = trim(ob_get_contents());
	ob_end_clean();
	if (trim(strip_tags($playhockey_out)) != '') {
		?>
		<div class="sidebar <?php echo esc_attr($playhockey_sidebar_position); ?> widget_area<?php if (!playhockey_is_inherit(playhockey_get_theme_option('sidebar_scheme'))) echo ' scheme_'.esc_attr(playhockey_get_theme_option('sidebar_scheme')); ?>" role="complementary">
			<div class="sidebar_inner">
				<?php
				do_action( 'playhockey_action_before_sidebar' );
				playhockey_show_layout(preg_replace("/<\/aside>[\r\n\s]*<aside/", "</aside><aside", $playhockey_out));
				do_action( 'playhockey_action_after_sidebar' );
				?>
			</div><!-- /.sidebar_inner -->
		</div><!-- /.sidebar -->
		<?php
	}
}
?>