<?php
/**
 * The template to display the site logo in the footer
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0.10
 */

// Logo
if (playhockey_is_on(playhockey_get_theme_option('logo_in_footer'))) {
	$playhockey_logo_image = '';
	if (playhockey_get_retina_multiplier(2) > 1)
		$playhockey_logo_image = playhockey_get_theme_option( 'logo_footer_retina' );
	if (empty($playhockey_logo_image)) 
		$playhockey_logo_image = playhockey_get_theme_option( 'logo_footer' );
	$playhockey_logo_text   = get_bloginfo( 'name' );
	if (!empty($playhockey_logo_image) || !empty($playhockey_logo_text)) {
		?>
		<div class="footer_logo_wrap">
			<div class="footer_logo_inner">
				<?php
				if (!empty($playhockey_logo_image)) {
					$playhockey_attr = playhockey_getimagesize($playhockey_logo_image);
					echo '<a href="'.esc_url(home_url('/')).'"><img src="'.esc_url($playhockey_logo_image).'" class="logo_footer_image" alt="'.esc_attr__('Image', 'playhockey').'"'.(!empty($playhockey_attr[3]) ? sprintf(' %s', $playhockey_attr[3]) : '').'></a>' ;
				} else if (!empty($playhockey_logo_text)) {
					echo '<h1 class="logo_footer_text"><a href="'.esc_url(home_url('/')).'">' . esc_html($playhockey_logo_text) . '</a></h1>';
				}
				?>
			</div>
		</div>
		<?php
	}
}
?>