<?php
/**
 * The template to display the widgets area in the footer
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0.10
 */

// Footer sidebar
$playhockey_footer_name = playhockey_get_theme_option('footer_widgets');
$playhockey_footer_present = !playhockey_is_off($playhockey_footer_name) && is_active_sidebar($playhockey_footer_name);
if ($playhockey_footer_present) { 
	playhockey_storage_set('current_sidebar', 'footer');
	$playhockey_footer_wide = playhockey_get_theme_option('footer_wide');
	ob_start();
    if ( is_active_sidebar( $playhockey_footer_name ) ) {
        dynamic_sidebar( $playhockey_footer_name );
    }
	$playhockey_out = trim(ob_get_contents());
	ob_end_clean();
	if (trim(strip_tags($playhockey_out)) != '') {
		$playhockey_out = preg_replace("/<\\/aside>[\r\n\s]*<aside/", "</aside><aside", $playhockey_out);
		$playhockey_need_columns = true;
		if ($playhockey_need_columns) {
			$playhockey_columns = max(0, (int) playhockey_get_theme_option('footer_columns'));
			if ($playhockey_columns == 0) $playhockey_columns = min(6, max(1, substr_count($playhockey_out, '<aside ')));
			if ($playhockey_columns > 1)
				$playhockey_out = preg_replace("/class=\"widget /", "class=\"column-1_".esc_attr($playhockey_columns).' widget ', $playhockey_out);
			else
				$playhockey_need_columns = false;
		}
		?>
		<div class="footer_widgets_wrap widget_area<?php echo !empty($playhockey_footer_wide) ? ' footer_fullwidth' : ''; ?>">
			<div class="footer_widgets_inner widget_area_inner">
				<?php 
				if (!$playhockey_footer_wide) { 
					?><div class="content_wrap"><?php
				}
				if ($playhockey_need_columns) {
					?><div class="columns_wrap"><?php
				}
				do_action( 'playhockey_action_before_sidebar' );
				playhockey_show_layout($playhockey_out);
				do_action( 'playhockey_action_after_sidebar' );
				if ($playhockey_need_columns) {
					?></div><!-- /.columns_wrap --><?php
				}
				if (!$playhockey_footer_wide) {
					?></div><!-- /.content_wrap --><?php
				}
				?>
			</div><!-- /.footer_widgets_inner -->
		</div><!-- /.footer_widgets_wrap -->
		<?php
	}
}
?>