<?php
/**
 * The template to display default site header
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_header_css = $playhockey_header_image = '';
$playhockey_header_video = wp_is_mobile() ? '' : playhockey_get_theme_option('header_video');
if (true || empty($playhockey_header_video)) {
	$playhockey_header_image = get_header_image();
	if (playhockey_is_on(playhockey_get_theme_option('header_image_override')) && apply_filters('playhockey_filter_allow_override_header_image', true)) {
		if (is_category()) {
			if (($playhockey_cat_img = playhockey_get_category_image()) != '')
				$playhockey_header_image = $playhockey_cat_img;
		} else if (is_singular() || playhockey_storage_isset('blog_archive')) {
			if (has_post_thumbnail()) {
				$playhockey_header_image = wp_get_attachment_image_src( get_post_thumbnail_id(), 'full' );
				if (is_array($playhockey_header_image)) $playhockey_header_image = $playhockey_header_image[0];
			} else
				$playhockey_header_image = '';
		}
	}
}

?><header class="top_panel top_panel_default<?php
					echo !empty($playhockey_header_image) || !empty($playhockey_header_video) ? ' with_bg_image' : ' without_bg_image';
					if ($playhockey_header_video!='') echo ' with_bg_video';
					if ($playhockey_header_image!='') echo ' '.esc_attr(playhockey_add_inline_style('background-image: url('.esc_url($playhockey_header_image).');'));
					if (is_single() && has_post_thumbnail()) echo ' with_featured_image';
					if (playhockey_is_on(playhockey_get_theme_option('header_fullheight'))) echo ' header_fullheight trx-stretch-height';
					?> scheme_<?php echo esc_attr(playhockey_is_inherit(playhockey_get_theme_option('header_scheme')) 
													? playhockey_get_theme_option('color_scheme') 
													: playhockey_get_theme_option('header_scheme'));
					?>"><?php
	
	// Main menu
	if (playhockey_get_theme_option("menu_style") == 'top') {
		get_template_part( 'templates/header-navi' );
	}

	// Page title and breadcrumbs area
	get_template_part( 'templates/header-title');

	// Header widgets area
	get_template_part( 'templates/header-widgets' );

	// Header for single posts
	get_template_part( 'templates/header-single' );

?></header>