<?php
/**
 * The template to display the logo or the site name and the slogan in the Header
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_args = get_query_var('playhockey_logo_args');

// Site logo
$playhockey_logo_image  = playhockey_get_logo_image(isset($playhockey_args['type']) ? $playhockey_args['type'] : '');
$playhockey_logo_text   = playhockey_is_on(playhockey_get_theme_option('logo_text')) ? get_bloginfo( 'name' ) : '';
$playhockey_logo_slogan = get_bloginfo( 'description', 'display' );
if (!empty($playhockey_logo_image) || !empty($playhockey_logo_text)) {
	?><a class="sc_layouts_logo" href="<?php echo esc_url(home_url('/')); ?>"><?php
		if (!empty($playhockey_logo_image)) {
			$playhockey_attr = playhockey_getimagesize($playhockey_logo_image);
			echo '<img src="'.esc_url($playhockey_logo_image).'" alt="'.esc_attr__('Image', 'playhockey').'"'.(!empty($playhockey_attr[3]) ? sprintf(' %s', $playhockey_attr[3]) : '').'>' ;
		} else {
			playhockey_show_layout(playhockey_prepare_macros($playhockey_logo_text), '<span class="logo_text">', '</span>');
			playhockey_show_layout(playhockey_prepare_macros($playhockey_logo_slogan), '<span class="logo_slogan">', '</span>');
		}
	?></a><?php
}
?>