<?php
/**
 * The template to display the page title and breadcrumbs
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

// Page (category, tag, archive, author) title

if ( playhockey_need_page_title() ) {
	set_query_var('playhockey_title_showed', true);
	?>
	<div class="top_panel_title sc_layouts_row">
		<div class="content_wrap">
			<div class="sc_layouts_column sc_layouts_column_align_center">
				<div class="sc_layouts_item">
					<div class="sc_layouts_title">
						<?php
						// Post meta on the single post
						// Blog/Post title
						?><div class="sc_layouts_title_title"><?php
							$playhockey_blog_title = playhockey_get_blog_title();
							$playhockey_blog_title_text = $playhockey_blog_title_class = $playhockey_blog_title_link = $playhockey_blog_title_link_text = '';
							if (is_array($playhockey_blog_title)) {
								$playhockey_blog_title_text = $playhockey_blog_title['text'];
								$playhockey_blog_title_class = !empty($playhockey_blog_title['class']) ? ' '.$playhockey_blog_title['class'] : '';
								$playhockey_blog_title_link = !empty($playhockey_blog_title['link']) ? $playhockey_blog_title['link'] : '';
								$playhockey_blog_title_link_text = !empty($playhockey_blog_title['link_text']) ? $playhockey_blog_title['link_text'] : '';
							} else
								$playhockey_blog_title_text = $playhockey_blog_title;
							?>
							<h1 class="sc_layouts_title_caption<?php echo esc_attr($playhockey_blog_title_class); ?>"><?php
								$playhockey_top_icon = playhockey_get_category_icon();
								if (!empty($playhockey_top_icon)) {
									$playhockey_attr = playhockey_getimagesize($playhockey_top_icon);
									?><img src="<?php echo esc_url($playhockey_top_icon); ?>" alt="<?php esc_attr__('Image', 'playhockey')?>" <?php if (!empty($playhockey_attr[3])) playhockey_show_layout($playhockey_attr[3]);?>><?php
								}
								echo wp_kses($playhockey_blog_title_text, 'playhockey_kses_content');
							?></h1>
							<?php
							if (!empty($playhockey_blog_title_link) && !empty($playhockey_blog_title_link_text)) {
								?><a href="<?php echo esc_url($playhockey_blog_title_link); ?>" class="theme_button theme_button_small sc_layouts_title_link"><?php echo esc_html($playhockey_blog_title_link_text); ?></a><?php
							}
							
							// Category/Tag description
							if ( is_category() || is_tag() || is_tax() ) 
								the_archive_description( '<div class="sc_layouts_title_description">', '</div>' );
		
						?></div><?php
	
						// Breadcrumbs
						?><div class="sc_layouts_title_breadcrumbs"><?php
							do_action( 'playhockey_action_breadcrumbs');
						?></div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<?php
}
?>