<?php
/**
 * The template to display the widgets area in the header
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

// Header sidebar
$playhockey_header_name = playhockey_get_theme_option('header_widgets');
$playhockey_header_present = !playhockey_is_off($playhockey_header_name) && is_active_sidebar($playhockey_header_name);
if ($playhockey_header_present) { 
	playhockey_storage_set('current_sidebar', 'header');
	$playhockey_header_wide = playhockey_get_theme_option('header_wide');
	ob_start();
    if ( is_active_sidebar( $playhockey_header_name ) ) {
        dynamic_sidebar( $playhockey_header_name );
    }
	$playhockey_widgets_output = ob_get_contents();
	ob_end_clean();
	if (trim(strip_tags($playhockey_widgets_output)) != '') {
		$playhockey_widgets_output = preg_replace("/<\/aside>[\r\n\s]*<aside/", "</aside><aside", $playhockey_widgets_output);
		$playhockey_need_columns = strpos($playhockey_widgets_output, 'columns_wrap')===false;
		if ($playhockey_need_columns) {
			$playhockey_columns = max(0, (int) playhockey_get_theme_option('header_columns'));
			if ($playhockey_columns == 0) $playhockey_columns = min(6, max(1, substr_count($playhockey_widgets_output, '<aside ')));
			if ($playhockey_columns > 1)
				$playhockey_widgets_output = preg_replace("/class=\"widget /", "class=\"column-1_".esc_attr($playhockey_columns).' widget ', $playhockey_widgets_output);
			else
				$playhockey_need_columns = false;
		}
		?>
		<div class="header_widgets_wrap widget_area<?php echo !empty($playhockey_header_wide) ? ' header_fullwidth' : ' header_boxed'; ?>">
			<div class="header_widgets_inner widget_area_inner">
				<?php 
				if (!$playhockey_header_wide) { 
					?><div class="content_wrap"><?php
				}
				if ($playhockey_need_columns) {
					?><div class="columns_wrap"><?php
				}
				do_action( 'playhockey_action_before_sidebar' );
				playhockey_show_layout($playhockey_widgets_output);
				do_action( 'playhockey_action_after_sidebar' );
				if ($playhockey_need_columns) {
					?></div>	<!-- /.columns_wrap --><?php
				}
				if (!$playhockey_header_wide) {
					?></div>	<!-- /.content_wrap --><?php
				}
				?>
			</div>	<!-- /.header_widgets_inner -->
		</div>	<!-- /.header_widgets_wrap -->
		<?php
	}
}
?>