<?php
/**
 * The template to display posts in widgets and/or in the search results
 *
 * @package WordPress
 * @subpackage PLAYHOCKEY
 * @since PLAYHOCKEY 1.0
 */

$playhockey_post_id    = get_the_ID();
$playhockey_post_date  = playhockey_get_date();
$playhockey_post_title = get_the_title();
$playhockey_post_link  = get_permalink();
$playhockey_post_author_id   = get_the_author_meta('ID');
$playhockey_post_author_name = get_the_author_meta('display_name');
$playhockey_post_author_url  = get_author_posts_url($playhockey_post_author_id, '');

$playhockey_args = get_query_var('playhockey_args_widgets_posts');
$playhockey_show_date = isset($playhockey_args['show_date']) ? (int) $playhockey_args['show_date'] : 1;
$playhockey_show_image = isset($playhockey_args['show_image']) ? (int) $playhockey_args['show_image'] : 1;
$playhockey_show_author = isset($playhockey_args['show_author']) ? (int) $playhockey_args['show_author'] : 1;
$playhockey_show_counters = isset($playhockey_args['show_counters']) ? (int) $playhockey_args['show_counters'] : 1;
$playhockey_show_categories = isset($playhockey_args['show_categories']) ? (int) $playhockey_args['show_categories'] : 1;

$playhockey_output = playhockey_storage_get('playhockey_output_widgets_posts');

$playhockey_post_counters_output = '';
if ( $playhockey_show_counters ) {
	$playhockey_post_counters_output = '<span class="post_info_item post_info_counters">'
								. playhockey_get_post_counters('comments')
							. '</span>';
}


$playhockey_output .= '<article class="post_item with_thumb">';

if ($playhockey_show_image) {
	$playhockey_post_thumb = get_the_post_thumbnail($playhockey_post_id, playhockey_get_thumb_size('tiny'), array(
		'alt' => the_title_attribute( array( 'echo' => false ) )
	));
	if ($playhockey_post_thumb) $playhockey_output .= '<div class="post_thumb">' . ($playhockey_post_link ? '<a href="' . esc_url($playhockey_post_link) . '">' : '') . ($playhockey_post_thumb) . ($playhockey_post_link ? '</a>' : '') . '</div>';
}

$playhockey_output .= '<div class="post_content">'
			. ($playhockey_show_categories 
					? '<div class="post_categories">'
						. playhockey_get_post_categories()
						. $playhockey_post_counters_output
						. '</div>' 
					: '')
			. '<h6 class="post_title">' . ($playhockey_post_link ? '<a href="' . esc_url($playhockey_post_link) . '">' : '') . ($playhockey_post_title) . ($playhockey_post_link ? '</a>' : '') . '</h6>'
			. apply_filters('playhockey_filter_get_post_info', 
								'<div class="post_info">'
									. ($playhockey_show_date 
										? '<span class="post_info_item post_info_posted">'
											. ($playhockey_post_link ? '<a href="' . esc_url($playhockey_post_link) . '" class="post_info_date">' : '') 
											. esc_html($playhockey_post_date) 
											. ($playhockey_post_link ? '</a>' : '')
											. '</span>'
										: '')
									. ($playhockey_show_author 
										? '<span class="post_info_item post_info_posted_by">' 
											. esc_html__('by', 'playhockey') . ' ' 
											. ($playhockey_post_link ? '<a href="' . esc_url($playhockey_post_author_url) . '" class="post_info_author">' : '') 
											. esc_html($playhockey_post_author_name) 
											. ($playhockey_post_link ? '</a>' : '') 
											. '</span>'
										: '')
									. (!$playhockey_show_categories && $playhockey_post_counters_output
										? $playhockey_post_counters_output
										: '')
								. '</div>')
		. '</div>'
	. '</article>';
playhockey_storage_set('playhockey_output_widgets_posts', $playhockey_output);
?>