<?php
/* Theme-specific action to configure ThemeREX Addons components
------------------------------------------------------------------------------- */

// Theme init priorities:
// 1 - register filters, that add/remove lists items for the Theme Options
if (!function_exists('playhockey_trx_addons_theme_specific_setup')) {
	add_action( 'after_setup_theme', 'playhockey_trx_addons_theme_specific_setup' );
	function playhockey_trx_addons_theme_specific_setup() {
		if (playhockey_exists_trx_addons()) {
			add_filter( 'trx_addons_filter_default_layouts',	'playhockey_trx_addons_theme_specific_default_layouts');

		}
	}
}

// Add theme-specific layouts to the VC user's layouts
if (!function_exists('playhockey_trx_addons_theme_specific_default_layouts')) {
	
	function playhockey_trx_addons_theme_specific_default_layouts($default_layouts=array()) {
        require_once trailingslashit( get_template_directory() ) . 'theme-specific/trx_addons.layouts.php';
		return isset($layouts) && is_array($layouts) && count($layouts) > 0
						? array_merge($default_layouts, $layouts)
						: $default_layouts;
	}
}

// Add new types in the shortcodes
if ( !function_exists( 'playhockey_trx_addons_sc_type' ) ) {
    add_filter( 'trx_addons_sc_type', 'playhockey_trx_addons_sc_type', 10, 2);
    function playhockey_trx_addons_sc_type($list, $sc) {
        if (in_array($sc, array('trx_sc_services'))) {
            $list[esc_html__('Image on background', 'playhockey')] = 'scimage';
        }
        if (in_array($sc, array('trx_sc_button'))) {
            $list[ esc_html__('Blue', 'playhockey') ] = 'blue_button';
        }
        return $list;
    }
}

if ( !function_exists('playhockey_sc_title_style') ) {
    add_filter('trx_addons_sc_type',     'playhockey_sc_title_style', 10, 2);
    function playhockey_sc_title_style($list, $sc) {
        if($sc == 'trx_sc_title') {
            $list[ esc_html__('Small title', 'playhockey') ] = 'small_title';
            $list[ esc_html__('Medium title', 'playhockey') ] = 'medium_title';
            $list[ esc_html__('Large title', 'playhockey') ] = 'large_title';
        }
        return $list;
    }
}