<?php
/**
 * The style "default" of the shortcode Matches (section "Main matches")
 *
 * @package WordPress
 * @subpackage ThemeREX Addons
 * @since v1.6.17
 */

$match = get_query_var('trx_addons_args_sc_matches_item');

$meta = $match['meta'];

// Competition type == 'pair'
if (!empty($meta['player1']) && !empty($meta['player2'])) {

	$is_match_page = is_single() && get_the_ID() == $match['id'];
	
	global $post;

	?><div class="sc_matches_item sc_matches_item_pair"><?php
		// Player 1
		?><div class="sc_matches_item_player sc_matches_item_player1"><?php
			$post = get_post($meta['player1']);
			setup_postdata($post);
			// Player's logo
			if (has_post_thumbnail()) {
				set_query_var('trx_addons_args_featured', apply_filters('trx_addons_filter_args_featured', array(
						'class' => 'sc_matches_item_thumb',
						'hover' => '',
						'thumb_size' => apply_filters('trx_addons_filter_thumb_size', trx_addons_get_thumb_size('masonry'), 'sport-player')
					), 'sport-player'));
					if (($fdir = trx_addons_get_file_dir('templates/tpl.featured.php')) != '') { include $fdir; }
			}
			// Name or Command
			?><div class="sc_matches_item_info"><h5 class="sc_matches_item_player_name"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h5><?php
			// Club or Country
			$player1_meta = get_post_meta($meta['player1'], 'trx_addons_options', true);
			if (!empty($player1_meta['club'])) {
				?><div class="sc_matches_item_player_meta"><h5 class="sc_matches_item_player_name"><?php echo esc_html($player1_meta['club']); ?></h5></div><?php
			}
		?></div></div><?php
			
		// Score
		?><div class="sc_matches_item_score"><?php
			if (!$is_match_page) {
				?><a href="<?php the_permalink($match['id']); ?>" class="sc_matches_item_link"><?php
			}
			if (!empty($meta['date_start'])) {
				?><span class="sc_matches_item_match_date"><?php echo date_i18n("d.m.Y", strtotime($meta['date_start'])); ?></span><?php
			}
			?><span class="sc_matches_item_score_value"><?php
				echo empty($meta['score']) ? esc_html__('vs', 'playhockey') : $meta['score'];
			?></span><?php
			if (!empty($meta['place'])) {
				?><span class="sc_matches_item_match_place"><?php echo esc_html($meta['place']); ?></span><?php
			}
			if (!empty($meta['review']) && !trx_addons_is_off($meta['review'])) {
				?><a class="sc_matches_item_review_link theme_button" href="<?php the_permalink($meta['review']); ?>"><span class="sc_matches_item_review_title"><?php esc_html_e('Match Review', 'playhockey'); ?></span></a><?php
			}
			if (!$is_match_page) {
				?></a><?php
			}
		?></div><?php

		// Player 2
		?><div class="sc_matches_item_player sc_matches_item_player2"><?php
			$post = get_post($meta['player2']);
			setup_postdata($post);

            // Name or Command
            ?><div class="sc_matches_item_info"><h5 class="sc_matches_item_player_name"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h5><?php
            // Club or Country
            $player2_meta = get_post_meta($meta['player2'], 'trx_addons_options', true);
            if (!empty($player2_meta['club'])) {
                ?><div class="sc_matches_item_player_meta"><h5 class="sc_matches_item_player_name"><?php echo esc_html($player2_meta['club']); ?></h5></div><?php
            }
            ?></div><?php

			// Player's logo
			if (has_post_thumbnail()) {
				set_query_var('trx_addons_args_featured', apply_filters('trx_addons_filter_args_featured', array(
					'class' => 'sc_matches_item_thumb',
					'hover' => '',
					'thumb_size' => apply_filters('trx_addons_filter_thumb_size', trx_addons_get_thumb_size('masonry'), 'sport-player')
				), 'sport-player'));
				if (($fdir = trx_addons_get_file_dir('templates/tpl.featured.php')) != '') { include $fdir; }
			}

		?></div>
	</div>
	<?php
	wp_reset_postdata();
}
?>